import React, { useState } from "react";
import "@grapecity/spread-sheets-designer-resources-en";
import { Designer } from "@grapecity/spread-sheets-designer-react";
import "@grapecity/spread-sheets-designer/styles/gc.spread.sheets.designer.min.css";
import "@grapecity/spread-sheets/styles/gc.spread.sheets.excel2013white.css";
import { toolbarConfig } from "./data1";
import GC from "@grapecity/spread-sheets";
import { CustomHeaderCellType } from "./settings";

let initialColumnNames = [];

export const getStylesForColumnHeader = (type) => {
  const style = new GC.Spread.Sheets.Style();
  style.hAlign = GC.Spread.Sheets.HorizontalAlign.center;
  style.vAlign = GC.Spread.Sheets.VerticalAlign.center;
  if (type === 'USER_CREATED') {
    style.foreColor = '#464646';
    style.backColor = '#ECF7E5';
  } else {
    style.foreColor = '#464646';
    style.backColor = '#FFFFFF';
  }
  return style;
};
export const handleCustomInsertColumn = (args, position) => {
  console.log("ABCDEFGH");

  let newlyInsertedColumnsIndexes = [];
  const sheet = args.Spread.getActiveSheet();
  let activeColumn = sheet.getSelections()[0].col;

  if ((activeColumn < 2 && position === 'RIGHT') || (activeColumn <= 2 && position === 'LEFT')) {
    return;
  }

  const table = sheet?.tables?.findByName('Table1');
  console.log("dfdfd", table.dataRange());
  const styleForUserCreatedColumn =
    getStylesForColumnHeader('USER_CREATED');
  sheet.suspendPaint();
  sheet.addColumns(sheet.getColumnCount(), 1);
  styleForUserCreatedColumn.cellType = new CustomHeaderCellType();
  sheet.addColumns(table.dataRange().colCount, 1);
  const isInsertAfter = position === 'LEFT' ? false : true;
  table.insertColumns(activeColumn, 1, isInsertAfter);
  // let applyStylesColumn = isInsertAfter ? activeColumn + 1 : activeColumn;

  // sheet.setStyle(
  //   0,
  //   applyStylesColumn,
  //   styleForUserCreatedColumn,
  //   GC.Spread.Sheets.SheetArea.viewport,
  // );
  // Get the table json
  let tableJSON = table.toJSON();
  tableJSON.columns.forEach((item, index) => {
    if (!initialColumnNames.includes(item.name)) {
      newlyInsertedColumnsIndexes.push(index);
    }
  });
  for (let i = 0; i < newlyInsertedColumnsIndexes.length; i++) {
    sheet.setStyle(
      0,
      newlyInsertedColumnsIndexes[i],
      styleForUserCreatedColumn,
      GC.Spread.Sheets.SheetArea.viewport,
    );
    sheet.setColumnWidth(newlyInsertedColumnsIndexes[i], 120, GC.Spread.Sheets.SheetArea.viewport);
    sheet
      .getRange(-1, newlyInsertedColumnsIndexes[i], -1, 1, GC.Spread.Sheets.SheetArea.viewport)
      .locked(false);
    sheet
      .getRange(-1, newlyInsertedColumnsIndexes[i], -1, 1, GC.Spread.Sheets.SheetArea.colHeader)
      .locked(false);
  }
  sheet.resumePaint();







};
const SampleComponent = () => {
  const getDesigner = async (designer) => {
    let data = toolbarConfig;

    const workbook = designer.getWorkbook();
    const activeSheet = workbook.getActiveSheet();
    activeSheet.setRowCount(7);
    activeSheet.setColumnCount(6);

    activeSheet.options.isProtected = true;
    var dataArray = [
      { Name: "Mike", Age: 23, Position: "Point Guard" },
      { Name: "Dave", Age: 22, Position: "Shoot Guard" },
      { Name: "Michael", Age: 21, Position: "Small Forward" },
      { Name: "Trey", Age: 22, Position: "Power Forward" },
      { Name: "Steve", Age: 21, Position: "Center" },
    ];


    activeSheet.tables.addFromDataSource(
      "Table1",
      0,
      0,
      dataArray,
      GC.Spread.Sheets.Tables.TableThemes.dark1
    );

    // Get the table by name
    let table = activeSheet.tables.findByName("Table1");
    let tableJSON = table.toJSON();
    initialColumnNames = [];
    // Store the initial column names in an array
    tableJSON.columns.forEach((item, index) => {
      initialColumnNames.push(item.name)
    })

    designer.setConfig(data);

  };

  return (
    <Designer
      designerInitialized={(designer) => {
        getDesigner(designer);
      }}
      styleInfo={{ width: "100%", height: "98vh" }}
    ></Designer>
  );
};

export default SampleComponent;
